/******************************************************************
SQL Saturday #110: March 10th, 2012, Tampa, FL

Dmitri Korotkevitch: "Service Broker - Why, When and Where

email: dmitri@aboutsqlserver.com
blog: http://aboutsqlserver.com

Server 1: Cross Server Referential Integrity

Disclamer: Scripts are provided for the demonstration purposes only.
Neither architecture nor database schema nor code are in production quality.
At bare minimum the following is missing:
	1. Exception & Poison Mesaging handling
	2. "Fire and Forget" pattern redesign
******************************************************************/
use SQLSat110
go

if exists
(
	select * 
	from sys.procedures p join sys.schemas s on
		p.schema_id = s.schema_id
	where
		s.name = 'dbo' and p.name = 'DeleteCustomer'
)
	drop proc dbo.DeleteCustomer
go

create proc dbo.DeleteCustomer(@CustomerId int)
as
begin
	set xact_abort on
	set nocount on
	begin tran
		delete from dbo.Customers where CustomerId = @CustomerId
		delete from STDSQLSERVER.SQLSat110_2.dbo.Customers where CustomerId = @CustomerId
	commit	
end
go

exec dbo.DeleteCustomer @CustomerId = 9999
go






if exists (
	select * 
	from sys.services 
	where name = 'RefIntegrityInitiatorService' 
)
	drop service RefIntegrityInitiatorService
go

if exists (
	select * 
	from sys.service_queues q join sys.schemas s on q.schema_id = s.schema_id
	where q.name = 'RefIntegrityInitiatorQueue' and s.name = 'dbo'
)
	drop queue dbo.RefIntegrityInitiatorQueue
go	

if exists (
	select * 
	from sys.service_contracts 
	where name = 'http://aboutsqlserver.com/RefIntegrityContract'
)
	drop contract [http://aboutsqlserver.com/RefIntegrityContract]
go

if exists (
	select * 
	from sys.service_message_types 
	where name = 'http://aboutsqlserver.com/RefIntegrityMessage'
)
	drop message type [http://aboutsqlserver.com/RefIntegrityMessage]
go

if exists 
(
	select * from sys.routes where name = 'RefIntegrity1to2Route'
)
	drop route RefIntegrity1to2Route
go


create message type [http://aboutsqlserver.com/RefIntegrityMessage]
authorization dbo
validation = WELL_FORMED_XML
go

create contract [http://aboutsqlserver.com/RefIntegrityContract]
authorization dbo
(
	[http://aboutsqlserver.com/RefIntegrityMessage] SENT BY INITIATOR
)
go

create  queue dbo.RefIntegrityInitiatorQueue
with
	Status = ON,
	Retention = OFF
go

create service RefIntegrityInitiatorService
authorization dbo
on queue dbo.RefIntegrityInitiatorQueue
([http://aboutsqlserver.com/RefIntegrityContract])
go


create route RefIntegrity1to2Route
with
	SERVICE_NAME = 'RefIntegrityTargetService',
	ADDRESS = 'TCP://11.2.1.51:4030'
GO



alter proc dbo.DeleteCustomer(@CustomerId int)
as
begin
	set xact_abort on
	set nocount on
	
	declare
		@XML xml
		,@ch uniqueidentifier

	select	
		@XML = 
			(	select  @CustomerId as [@Id]
				for xml path('Customer'), root('Deletion')
			)
			
	select @XML
					
	begin tran
		-- Delete local customer
		delete from dbo.Customers where CustomerId = @CustomerId

		-- And put the message to the queue
		begin dialog @ch
		from service RefIntegrityInitiatorService
		to service 'RefIntegrityTargetService'
		on contract [http://aboutsqlserver.com/RefIntegrityContract]
		with encryption = off;

		send on conversation @ch
		message type [http://aboutsqlserver.com/RefIntegrityMessage]
		(@XML);
		
		end conversation @ch -- be careful with fire and forget pattern
	commit	
end
go



declare
	@CustomerId int = 505
	
exec dbo.DeleteCustomer @CustomerId
go


declare
	@CustomerId int = 506
	
--exec dbo.DeleteCustomer @CustomerId
select * from dbo.Customers where CustomerId = @CustomerId
select convert(XML, Message_Body) from dbo.RefIntegrityInitiatorQueue
select * from sys.transmission_queue
select * from sys.conversation_endpoints
select * from sys.remote_service_bindings
go

