/******************************************************************
SQL Saturday #110: March 10th, 2012, Tampa, FL

Dmitri Korotkevitch: "Service Broker - Why, When and Where

email: dmitri@aboutsqlserver.com
blog: http://aboutsqlserver.com

Server 1: SOA

This is oversimplified example with fully serialized algorithm. 
Conversation groups are not used

Disclamer: Scripts are provided for the demonstration purposes only.
Neither architecture nor database schema nor code are in production quality.
At bare minimum the following is missing:
	1. Exception & Poison Mesaging handling
	2. "Fire and Forget" pattern redesign
******************************************************************/

use SQLSat110
go

if exists 
(
	select * from sys.routes where name = 'SOAPayment1to2Route'
)
	drop route SOAPayment1to2Route
go

if exists (
	select * 
	from sys.remote_service_bindings 
	where name = 'SOAServiceBinding'
)
	drop remote service binding SOAServiceBinding
go

if exists (
	select * 
	from sys.services 
	where name = 'SOACustomerService' 
)
	drop service SOACustomerService
go

if exists (
	select * 
	from sys.services 
	where name = 'SOAOrderService' 
)
	drop service SOAOrderService
go

if exists (
	select * 
	from sys.services 
	where name = 'SOAPaymentService' 
)
	drop service SOAPaymentService
go

if exists (
	select * 
	from sys.services 
	where name = 'SOAReservationService' 
)
	drop service SOAReservationService
go

if exists (
	select * 
	from sys.services 
	where name = 'SOAFulfillmentService' 
)
	drop service SOAFulfillmentService
go

if exists (
	select * 
	from sys.service_queues q join sys.schemas s on q.schema_id = s.schema_id
	where q.name = 'SOACustomerQueue' and s.name = 'dbo'
)
	drop queue dbo.SOACustomerQueue
go

if exists (
	select * 
	from sys.service_queues q join sys.schemas s on q.schema_id = s.schema_id
	where q.name = 'SOAFulfillmentQueue' and s.name = 'dbo'
)
	drop queue dbo.SOAFulfillmentQueue
go

if exists (
	select * 
	from sys.service_queues q join sys.schemas s on q.schema_id = s.schema_id
	where q.name = 'SOAReservationQueue' and s.name = 'dbo'
)
	drop queue dbo.SOAReservationQueue
go

if exists (
	select * 
	from sys.service_queues q join sys.schemas s on q.schema_id = s.schema_id
	where q.name = 'SOAPaymentQueue' and s.name = 'dbo'
)
	drop queue dbo.SOAPaymentQueue
go

if exists (
	select * 
	from sys.service_queues q join sys.schemas s on q.schema_id = s.schema_id
	where q.name = 'SOAOrderQueue' and s.name = 'dbo'
)
	drop queue dbo.SOAOrderQueue
go

if exists (
	select * 
	from sys.service_contracts 
	where name = 'http://aboutsqlserver.com/SOAPaymentContract'
)
	drop contract [http://aboutsqlserver.com/SOAPaymentContract]
go

if exists (
	select * 
	from sys.service_contracts 
	where name = 'http://aboutsqlserver.com/SOACustomerContract'
)
	drop contract [http://aboutsqlserver.com/SOACustomerContract]
go

if exists (
	select * 
	from sys.service_contracts 
	where name = 'http://aboutsqlserver.com/SOAReservationContract'
)
	drop contract [http://aboutsqlserver.com/SOAReservationContract]
go


if exists (
	select * 
	from sys.service_contracts 
	where name = 'http://aboutsqlserver.com/SOAFulfillmentContract'
)
	drop contract [http://aboutsqlserver.com/SOAFulfillmentContract]
go


if exists (
	select * 
	from sys.service_message_types 
	where name = 'http://aboutsqlserver.com/SOAPaymentRequest'
)
	drop message type [http://aboutsqlserver.com/SOAPaymentRequest]
go

if exists (
	select * 
	from sys.service_message_types 
	where name = 'http://aboutsqlserver.com/SOANewOrder'
)
	drop message type [http://aboutsqlserver.com/SOANewOrder]
go

if exists (
	select * 
	from sys.service_message_types 
	where name = 'http://aboutsqlserver.com/SOAPaymentResponse'
)
	drop message type [http://aboutsqlserver.com/SOAPaymentResponse]
go

if exists (
	select * 
	from sys.service_message_types 
	where name = 'http://aboutsqlserver.com/SOAReservationRequest'
)
	drop message type [http://aboutsqlserver.com/SOAReservationRequest]
go

if exists (
	select * 
	from sys.service_message_types 
	where name = 'http://aboutsqlserver.com/SOAReservationResponse'
)
	drop message type [http://aboutsqlserver.com/SOAReservationResponse]
go

if exists (
	select * 
	from sys.service_message_types 
	where name = 'http://aboutsqlserver.com/SOAFulfillmentRequest'
)
	drop message type [http://aboutsqlserver.com/SOAFulfillmentRequest]
go

if exists (
	select * 
	from sys.service_message_types 
	where name = 'http://aboutsqlserver.com/SOAFulfillmentResponse'
)
	drop message type [http://aboutsqlserver.com/SOAFulfillmentResponse]
go

if exists
(
	select * 
	from sys.procedures p join sys.schemas s on
		p.schema_id = s.schema_id
	where
		s.name = 'dbo' and p.name = 'SOAOrderQueueProc'
)
	drop proc dbo.SOAOrderQueueProc
go

if exists
(
	select * 
	from sys.procedures p join sys.schemas s on
		p.schema_id = s.schema_id
	where
		s.name = 'dbo' and p.name = 'SOAPaymentQueueProc'
)
	drop proc dbo.SOAPaymentQueueProc
go

if exists
(
	select * 
	from sys.procedures p join sys.schemas s on
		p.schema_id = s.schema_id
	where
		s.name = 'dbo' and p.name = 'SOAReservationQueueProc'
)
	drop proc dbo.SOAReservationQueueProc
go

if exists
(
	select * 
	from sys.procedures p join sys.schemas s on
		p.schema_id = s.schema_id
	where
		s.name = 'dbo' and p.name = 'SOAFulfillmentQueueProc'
)
	drop proc dbo.SOAFulfillmentQueueProc
go

create message type [http://aboutsqlserver.com/SOANewOrder]
authorization dbo
validation = WELL_FORMED_XML
go

create message type [http://aboutsqlserver.com/SOAPaymentRequest]
authorization dbo
validation = WELL_FORMED_XML
go

create message type [http://aboutsqlserver.com/SOAPaymentResponse]
authorization dbo
validation = WELL_FORMED_XML
go

create message type [http://aboutsqlserver.com/SOAReservationRequest]
authorization dbo
validation = WELL_FORMED_XML
go

create message type [http://aboutsqlserver.com/SOAReservationResponse]
authorization dbo
validation = WELL_FORMED_XML
go

create message type [http://aboutsqlserver.com/SOAFulfillmentRequest]
authorization dbo
validation = WELL_FORMED_XML
go

create message type [http://aboutsqlserver.com/SOAFulfillmentResponse]
authorization dbo
validation = WELL_FORMED_XML
go

create contract [http://aboutsqlserver.com/SOACustomerContract]
authorization dbo
(
	[http://aboutsqlserver.com/SOANewOrder] SENT BY INITIATOR
)
go

create contract [http://aboutsqlserver.com/SOAPaymentContract]
authorization dbo
(
	[http://aboutsqlserver.com/SOAPaymentRequest] SENT BY INITIATOR,
	[http://aboutsqlserver.com/SOAPaymentResponse] SENT BY TARGET
	
)
go

create contract [http://aboutsqlserver.com/SOAReservationContract]
authorization dbo
(
	[http://aboutsqlserver.com/SOAReservationRequest] SENT BY INITIATOR,
	[http://aboutsqlserver.com/SOAReservationResponse] SENT BY TARGET
	
)
go

create contract [http://aboutsqlserver.com/SOAFulfillmentContract]
authorization dbo
(
	[http://aboutsqlserver.com/SOAFulfillmentRequest] SENT BY INITIATOR,
	[http://aboutsqlserver.com/SOAFulfillmentResponse] SENT BY TARGET
)
go

create queue dbo.SOACustomerQueue
with
	Status = ON,
	Retention = OFF
go

create proc dbo.SOAOrderQueueProc
with execute as owner
as
	return
go

create queue dbo.SOAOrderQueue
with
	Status = ON,
	Retention = OFF,
	Activation
	(
		Status = ON,
		Procedure_Name = dbo.SOAOrderQueueProc,
		MAX_QUEUE_READERS = 1, 
		EXECUTE AS OWNER
	)
go

create proc dbo.SOAPaymentQueueProc
with execute as owner
as
	return
go

create queue dbo.SOAPaymentQueue
with
	Status = ON,
	Retention = OFF,
	Activation
	(
		Status = ON,
		Procedure_Name = dbo.SOAPaymentQueueProc,
		MAX_QUEUE_READERS = 1, 
		EXECUTE AS OWNER
	)
go

create proc dbo.SOAReservationQueueProc
with execute as owner
as
	return
go

create queue dbo.SOAReservationQueue
with
	Status = ON,
	Retention = OFF,
	Activation
	(
		Status = ON,
		Procedure_Name = dbo.SOAReservationQueueProc,
		MAX_QUEUE_READERS = 1, 
		EXECUTE AS OWNER
	)
go

create proc dbo.SOAFulfillmentQueueProc
with execute as owner
as
	return
go

create queue dbo.SOAFulfillmentQueue
with
	Status = ON,
	Retention = OFF,
	Activation
	(
		Status = ON,
		Procedure_Name = dbo.SOAFulfillmentQueueProc,
		MAX_QUEUE_READERS = 1, 
		EXECUTE AS OWNER
	)
go

create service SOACustomerService
authorization dbo
on queue dbo.SOACustomerQueue
(
	[http://aboutsqlserver.com/SOACustomerContract]
)
go

create service SOAOrderService
authorization dbo
on queue dbo.SOAOrderQueue
(
	[http://aboutsqlserver.com/SOACustomerContract],
	[http://aboutsqlserver.com/SOAPaymentContract],
	[http://aboutsqlserver.com/SOAReservationContract],
	[http://aboutsqlserver.com/SOAFulfillmentContract]
)
go

create service SOAPaymentService
authorization dbo
on queue dbo.SOAPaymentQueue
(
	[http://aboutsqlserver.com/SOAPaymentContract]
)
go

create service SOAReservationService
authorization dbo
on queue dbo.SOAReservationQueue
(
	[http://aboutsqlserver.com/SOAReservationContract]
)
go

create service SOAFulfillmentService
authorization dbo
on queue dbo.SOAFulfillmentQueue
(
	[http://aboutsqlserver.com/SOAFulfillmentContract]
)
go



if exists
(
	select * 
	from sys.procedures p join sys.schemas s on
		p.schema_id = s.schema_id
	where
		s.name = 'dbo' and p.name = 'NewOrder'
)
	drop proc dbo.NewOrder
go

if exists
(
	select * 
	from sys.types t join sys.schemas s on
		t.schema_id = s.schema_id
	where
		s.name = 'dbo' and t.name = 'tvpOrderItems'
)
	drop type dbo.tvpOrderItems
go

create type dbo.tvpOrderItems
as table
(
	ArticleId int not null,
	Quantity int not null,
	Price money not null,
	
	primary key (ArticleId)
)
go

create proc [dbo].[NewOrder]
(
	@CustomerId int,
	@Items dbo.tvpOrderItems READONLY
)
as
begin
	set xact_abort on
	set nocount on
	
	declare
		@OrderId int 
		,@MSG xml
		,@ch uniqueidentifier		
		
	-- we want to do everything in one transaction
	begin tran
		-- Insert Order record calculating Amount
		insert into dbo.Orders(CustomerId,Amount)
			select @CustomerId, SUM(Price * Quantity)
			from @Items
			
		-- Get ID
		select @OrderId = SCOPE_IDENTITY()

		insert into dbo.OrderItems(OrderId, ArticleId, Price, Quantity)
			select @OrderId, ArticleId, Price, Quantity
			from @Items
		
		-- Serialize OrderId to XML
		select @Msg = 
			(
				select @OrderId as [@OrderId]
				for XML path('Order')
			)
		
		-- And Send "New Order" Message to Order Service
		begin dialog @ch
		from service SOACustomerService
		to service N'SOAOrderService'
		on contract [http://aboutsqlserver.com/SOACustomerContract]
		with encryption = off;

		send on conversation @ch
		message type [http://aboutsqlserver.com/SOANewOrder]
		(@Msg);		
			
		-- beware of "fire and forget pattern
		end conversation @ch
	commit	
end	
go

alter proc dbo.SOAOrderQueueProc
with execute as owner
as
begin
	set nocount on
	
	declare
		@ch uniqueidentifier
		,@MessageBody as varbinary(max)
		,@MessageType as sysname
		,@MsgXml xml
		,@OrderId int
		,@CustomerId int
		,@PaymentInfo varchar(255)
		,@MSG2 xml
		,@ch2 uniqueidentifier
		,@Response varchar(255)						
		
	while 1 = 1
	begin
		begin tran
			WAITFOR
			(
				RECEIVE top (1)
					@MessageType = message_type_name,
					@ch = conversation_handle,
					@MessageBody = message_body
				FROM dbo.SOAOrderQueue
			), TIMEOUT 60000

			if @@ROWCOUNT = 0
			begin
				rollback
				break
			end

			insert into dbo.SBLog(Queue, MsgType, MsgBody)			
			values('SOAOrderQueue',@MessageType,CONVERT(xml,@MessageBody))
			
			if @MessageType = 'http://aboutsqlserver.com/SOANewOrder' -- New Order in the system
			begin
				-- Get Required Info from Message and Orders table
				select @MsgXml = CONVERT(xml,@MessageBody)
				select 
					@OrderId = @MsgXml.value('/Order[1]/@OrderId','int')
					,@PaymentInfo = @MsgXml.value('/Order[1]/@PaymentInfo','varchar(255)')
				select @CustomerId = CustomerId from dbo.Orders where OrderId = @OrderId
				
				-- Serialize data to XML
				select @Msg2 = 
					(
						select 
							'AUTH' as [@Action],
							@OrderId as [@OrderId],
							@CustomerId as [@CustomerId], 
							@PaymentInfo as [@PaymentInfo]
						for XML path('Tran')
					)
				
				-- Start another conversation with Payment service
				-- We do everything in "serialized" matter 
				-- So different conversation is OK
				-- Otherwise we need to use conversation groups to serialize/lock stuff
				begin dialog @ch2
				from service SOAOrderService
				to service N'SOAPaymentService'
				on contract [http://aboutsqlserver.com/SOAPaymentContract]
				with encryption = off;

				send on conversation @ch2
				message type [http://aboutsqlserver.com/SOAPaymentRequest]
				(@Msg2);		
			
				-- End conversation with Customer Service
				end conversation @ch
			end
			else if @MessageType = 'http://aboutsqlserver.com/SOAPaymentResponse'
			begin
				-- Response from Payment Service 
				select @MsgXml = CONVERT(xml,@MessageBody)
				select 
					@OrderId = @MsgXml.value('/Tran[1]/@OrderId','int')
					,@Response = @MsgXml.value('/Tran[1]/@Response','varchar(255)')
				if @Response = 'OK' -- credit card authorized
				begin
					update dbo.Orders set Paid = 1 where OrderId = @OrderId
				
					select @Msg2 = 
						(
							select 
								@OrderId as [@OrderId]
							for XML path('Order')
						)
				
					-- Start conversation with Reservation Service
					begin dialog @ch2
					from service SOAOrderService
					to service N'SOAReservationService'
					on contract [http://aboutsqlserver.com/SOAReservationContract]
					with encryption = off;

					send on conversation @ch2
					message type [http://aboutsqlserver.com/SOAReservationRequest]
					(@Msg2);
					-- Notify customer that CC has been charged		
				end
				else begin -- credit card did not go through
					update dbo.Orders set Active = 0 where OrderId = @OrderId
					-- Notify customer that order has been cancelled
				end
				
				-- End conversation with Payment Service
				end conversation @ch
			end
			else if @MessageType = 'http://aboutsqlserver.com/SOAReservationResponse'
			begin
				-- Response from Reservation Service 
				select @MsgXml = CONVERT(xml,@MessageBody)
				select 
					@OrderId = @MsgXml.value('/Order[1]/@OrderId','int')
					,@Response = @MsgXml.value('/Order[1]/@Response','varchar(255)')
				if @Response = 'OK' -- Articles reserved
				begin
					update dbo.Orders set ArticlesReserved = 1 where OrderId = @OrderId
				
					select @Msg2 = 
						(
							select 
								@OrderId as [@OrderId]
							for XML path('Order')
						)
				
					-- Start conversation with Fulfillment service
					begin dialog @ch2
					from service SOAOrderService
					to service N'SOAFulfillmentService'
					on contract [http://aboutsqlserver.com/SOAFulfillmentContract]
					with encryption = off;

					send on conversation @ch2
					message type [http://aboutsqlserver.com/SOAFulfillmentRequest]
					(@Msg2);
					-- Notify customer that CC has been charged		
				end
				else begin -- credit card did not go through
					update dbo.Orders set Active = 0 where OrderId = @OrderId
					-- *** SEND MESSAGE TO PAYMENT SERVICE TO REFUND THE PAYMENT ***
					-- Notify customer that order has been cancelled
				end
				-- End conversation with Reservation Service
				end conversation @ch
			end
			else if @MessageType = 'http://aboutsqlserver.com/SOAFulfillmentResponse'
			begin
				select @MsgXml = CONVERT(xml,@MessageBody)
				select 
					@OrderId = @MsgXml.value('/Order[1]/@OrderId','int')
				
				update dbo.Orders set Shipped = 1, Active = 0, ShipmentDate = GETUTCDATE() where OrderId = @OrderId
				-- ***NOTIFY CUSTOMER ***
				-- End conversation with fullfilment service
				end conversation @ch
			end
			-- else ... handle other messages types
		commit
	end
end
go

alter proc dbo.SOAPaymentQueueProc
with execute as owner
as
begin
	set nocount on
	
	declare
		@ch uniqueidentifier
		,@MessageBody as varbinary(max)
		,@MessageType as sysname
		,@MsgXml xml
		,@OrderId int
		,@CustomerId int
		,@PaymentInfo varchar(255)
		,@Action varchar(255)
		,@Response varchar(255)
		,@MSG2 xml
		
	while 1 = 1
	begin
		begin tran
			WAITFOR
			(
				RECEIVE top (1)
					@MessageType = message_type_name,
					@ch = conversation_handle,
					@MessageBody = message_body
				FROM dbo.SOAPaymentQueue
			), TIMEOUT 60000

			if @@ROWCOUNT = 0
			begin
				rollback
				break
			end

			insert into dbo.SBLog(Queue, MsgType, MsgBody)			
			values('SOAPaymentQueue',@MessageType,CONVERT(xml,@MessageBody))
			
			if @MessageType = 'http://aboutsqlserver.com/SOAPaymentRequest'
			begin
				select @MsgXml = CONVERT(xml,@MessageBody)
				select 
					@OrderId = @MsgXml.value('/Tran[1]/@OrderId','int')
					,@CustomerId = @MsgXml.value('/Tran[1]/@CustomerId','int')
					,@PaymentInfo = @MsgXml.value('/Tran[1]/@PaymentInfo','varchar(255)')
					,@Action = @MsgXml.value('/Tran[1]/@Action','varchar(255)')

				if @Action = 'AUTH'
				begin
					-- Authorizing payment
					select @Response = 'OK'
					waitfor delay '0:00:01.000'
				end
				else if @Action = 'REFUND'
				begin
					-- Authorizing payment
					select @Response = 'OK'
					waitfor delay '0:00:01.000'
				end
				
				select @Msg2 = 
					(
						select 
							@OrderId as [@OrderId],
							@Response as [@Response]
						for XML path('Tran')
					);
				
				send on conversation @ch
				message type [http://aboutsqlserver.com/SOAPaymentResponse]
				(@Msg2);		
			
				end conversation @ch
			end
			-- else ... handle other messages types
		commit
	end
end
go

alter proc dbo.SOAReservationQueueProc
with execute as owner
as
begin
	set nocount on
	
	declare
		@ch uniqueidentifier
		,@MessageBody as varbinary(max)
		,@MessageType as sysname
		,@MsgXml xml
		,@OrderId int
		,@CustomerId int
		,@PaymentInfo varchar(255)
		,@Action varchar(255)
		,@Response varchar(255)
		,@MSG2 xml
		
	while 1 = 1
	begin
		begin tran
			WAITFOR
			(
				RECEIVE top (1)
					@MessageType = message_type_name,
					@ch = conversation_handle,
					@MessageBody = message_body
				FROM dbo.SOAReservationQueue
			), TIMEOUT 60000

			if @@ROWCOUNT = 0
			begin
				rollback
				break
			end

			insert into dbo.SBLog(Queue, MsgType, MsgBody)			
			values('SOAReservationQueue',@MessageType,CONVERT(xml,@MessageBody))
			
			if @MessageType = 'http://aboutsqlserver.com/SOAReservationRequest'
			begin
				select @MsgXml = CONVERT(xml,@MessageBody)
				select 
					@OrderId = @MsgXml.value('/Order[1]/@OrderId','int')

				if exists
				(
					select * 
					from dbo.Articles a with (UPDLOCK)
					where exists
					(
						select * 
						from dbo.OrderItems i 
						where 
							i.OrderId = @OrderId and 
							i.ArticleId = a.ArticleId and 
							a.RemainingStock < i.Quantity
					)
				)
					select @Response = 'INSIFFICIENT STOCK'
				else begin
					select @Response = 'OK'
				
					update	dbo.Articles 
					set
						dbo.Articles.RemainingStock -= i.Quantity
					from dbo.Articles join dbo.OrderItems i on
						i.OrderId = @OrderId and i.ArticleId = dbo.Articles.ArticleId
				end

				waitfor delay '0:00:01.000'
			
				select @Msg2 = 
					(
						select 
							@OrderId as [@OrderId],
							@Response as [@Response]
						for XML path('Order')
					);
				
				send on conversation @ch
				message type [http://aboutsqlserver.com/SOAReservationResponse]
				(@Msg2);		
			
				end conversation @ch
			end
			-- else ... handle other messages types
		commit
	end
end
go

alter proc dbo.SOAFulfillmentQueueProc
with execute as owner
as
begin
	set nocount on
	
	declare
		@ch uniqueidentifier
		,@MessageBody as varbinary(max)
		,@MessageType as sysname
		,@MsgXml xml
		,@OrderId int
		,@CustomerId int
		,@PaymentInfo varchar(255)
		,@Action varchar(255)
		,@Response varchar(255)
		,@MSG2 xml
		
	while 1 = 1
	begin
		begin tran
			WAITFOR
			(
				RECEIVE top (1)
					@MessageType = message_type_name,
					@ch = conversation_handle,
					@MessageBody = message_body
				FROM dbo.SOAFulfillmentQueue
			), TIMEOUT 60000

			if @@ROWCOUNT = 0
			begin
				rollback
				break
			end

			insert into dbo.SBLog(Queue, MsgType, MsgBody)			
			values('SOAFulfillmentQueue',@MessageType,CONVERT(xml,@MessageBody))
			
			if @MessageType = 'http://aboutsqlserver.com/SOAFulfillmentRequest'
			begin
				select @MsgXml = CONVERT(xml,@MessageBody)
				select 
					@OrderId = @MsgXml.value('/Order[1]/@OrderId','int')

				waitfor delay '0:00:05.000'  -- we're lucky our order shipped in 5 seconds
			
				select @Msg2 = 
					(
						select 
							@OrderId as [@OrderId],
							'OK' as [@Response]
						for XML path('Order')
					);
				
				send on conversation @ch
				message type [http://aboutsqlserver.com/SOAFulfillmentResponse]
				(@Msg2);		
			
				end conversation @ch
			end
			-- else ... handle other messages types
		commit
	end
end
go

delete from dbo.SBLog
go

declare
	@CustomerId int = 2
	,@Items dbo.tvpOrderItems
	
insert into @Items(ArticleId, Price, Quantity)
values(1,10,1),(2,20,2),(3,30,3)

exec dbo.NewOrder @CustomerId, @Items
go

select * from dbo.Orders
select * from dbo.OrderItems
select * from dbo.SBLog order by ID desc
go

select * from sys.transmission_queue
select * from sys.conversation_endpoints
go

