/******************************************************************
SQL Saturday #110: March 10th, 2012, Tampa, FL

Dmitri Korotkevitch: "Service Broker - Why, When and Where

email: dmitri@aboutsqlserver.com
blog: http://aboutsqlserver.com

Server 1: SOA - Moving Payment Service to remote location

Disclamer: Scripts are provided for the demonstration purposes only.
Neither architecture nor database schema nor code are in production quality.
At bare minimum the following is missing:
	1. Exception & Poison Mesaging handling
	2. "Fire and Forget" pattern redesign
******************************************************************/
use SQLSat110
go

if exists (
	select * 
	from sys.services 
	where name = 'SOAPaymentService' 
)
	drop service SOAPaymentService
go


if exists 
(
	select * from sys.routes where name = 'SOAPayment1to2Route'
)
	drop route SOAPayment1to2Route
go

if exists (
	select * 
	from sys.remote_service_bindings 
	where name = 'SOAServiceBinding'
)
	drop remote service binding SOAServiceBinding
go

-- ROUTE - Where the service is located
create route SOAPayment1to2Route
with
	SERVICE_NAME = 'SOAPaymentService',
	ADDRESS = 'TCP://11.2.1.51:4030'
GO

-- Some Security configuration 
GRANT SEND ON SERVICE::SOAOrderService To Server2User;
GO

CREATE REMOTE SERVICE BINDING SOAServiceBinding
TO SERVICE 'SOAPaymentService'
WITH USER = Server2User
go

