/******************************************************************
SQL Saturday #110: March 10th, 2012, Tampa, FL

Dmitri Korotkevitch: "Service Broker - Why, When and Where

email: dmitri@aboutsqlserver.com
blog: http://aboutsqlserver.com

Server 2: Database initialization script

Disclamer: Scripts are provided for the demonstration purposes only.
Neither architecture nor database schema nor code are in production quality.
At bare minimum the following is missing:
	1. Exception & Poison Mesaging handling
	2. "Fire and Forget" pattern redesign
******************************************************************/

use SqlSat110_2 
go

if exists
(
	select * 
	from sys.tables t join sys.schemas s on
		t.schema_id = s.schema_id
	where
		s.name = 'dbo' and t.name = 'SBLog'
)
	drop table dbo.SBLog
go


-- Let's create table for logging
create table dbo.SBLog
(
	ID int not null identity(1,1),
	ATime datetime not null
		constraint DEF_SBLog
		default getDate(),
	Queue sysname not null,
	MsgType sysname not null,
	MsgBody xml null,
	Comment varchar(max),
	
	constraint PK_SBLog
	primary key clustered(ID)
)
go


if exists
(
	select * 
	from sys.tables t join sys.schemas s on
		t.schema_id = s.schema_id
	where
		s.name = 'dbo' and t.name = 'Customers'
)
	drop table dbo.Customers
go

create table dbo.Customers
(
	CustomerId int not null,
	CustomerName nvarchar(64) not null,
	NotificationAddress nvarchar(128) null,
	NotificationMethod tinyint not null
		constraint DEF_Customers_NotificationMethod
		default 0,
		
	constraint PK_Customers
	primary key clustered(CustomerId)
)
go

;with Ids(ID)
as
(
	select 1 
	union all 
	select ID + 1
	from Ids 
	where ID < 500000
)
insert into dbo.Customers(CustomerId,CustomerName,NotificationAddress,NotificationMethod)
	select 
		ID, 
		'Customer: ' + CONVERT(nvarchar(10),Id),
		'Address: ' + CONVERT(nvarchar(10),Id),
		ID % 2
	from Ids
option (maxrecursion 0)
go

